//! # the idCoop crate
//!
//! idCoop is an application but this crate is exposed to allow for easier integration testing.
//! (This is just personal style: the entrypoint is in `src/bin` and is only a thin wrapper around the `idcoop` crate.)

#![deny(missing_docs)]

pub mod cli;
pub mod config;
pub mod passwords;
pub mod store;
pub mod utils;
pub mod web;

#[cfg(test)]
mod tests;
